> Calendly developer docs. For page Markdown, append .md to any URL.
> Index: https://developer.calendly.com/llms.txt
> API catalog: https://developer.calendly.com/.well-known/api-catalog
> OpenAPI: https://developer.calendly.com/openapi/calendly-api.yaml
> OAuth authorization server: https://calendly.com/.well-known/oauth-authorization-server
> MCP protected resource: https://mcp.calendly.com/.well-known/oauth-protected-resource
> Scheduling MCP endpoint: https://mcp.calendly.com
> Docs search MCP: https://developer.calendly.com/_mcp/server

# Create User Availability Schedule

POST https://api.calendly.com/user_availability_schedules
Content-Type: application/json

Creates a new availability schedule for the authenticated user. The schedule is not applied to any event type until configured separately.

**Rules requirements:**

* Must include exactly one `wday` rule for each day of the week (sunday through saturday).
* `date` rules are optional overrides on top of the weekly rules.
* Date rules dated before today, in the schedule's timezone, will return `400 Bad Request`.
* An empty `intervals` array means no availability for that weekday or date.

> `availability:write`

Reference: https://developer.calendly.com/api-docs/calendly-api/availability/create-user-availability-schedule

## Authentication

- `Authorization` header (bearer token, required) — OAuth 2.0
- `Authorization` header (bearer token, required) — Personal Access Token

## Request

### Body (application/json)

This endpoint expects an object.

- `name` (string, required) — The name of this Availability Schedule.
- `timezone` (string, required) — The timezone for which this Availability Schedule is originated in.
- `rules` (list of AvailabilityRule, required) — Complete set of availability rules for the schedule. Must include exactly one wday rule for each day of the week. date rules are optional overrides on top of the weekly rules.

## Response

### 201

Created

- `resource` (AvailabilitySchedule, required) — The availability schedule set by the user.

## Errors

### 400 Bad Request Error

Bad Request - Invalid arguments, including: - Missing required fields (name, timezone, or rules) - Missing wday rules for one or more days of the week - Date rules dated before today in the schedule's timezone - Invalid time formats or timezone values

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 401 Unauthorized Error

Cannot authenticate caller

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 403 Forbidden Error

Caller not authorized to perform this action or insufficient scope

- `Create-user-availability-scheduleRequestForbiddenError`
  - UserNotInOrganizationError: UserNotInOrganizationError
  - InsufficientScopeError: InsufficientScopeError

### 429 Too Many Requests Error

Too Many Requests

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

### 500 Internal Server Error

An error has occurred on the server

- `title` (enum, required)
  - Allowed values: `Internal Server Error`
- `message` (enum, required)
  - Allowed values: `The server encountered an unexpected condition that prevented it from fulfilling the request.`
- `details` (list of ErrorResponseDetailsItem, optional)

## Types

### AvailabilityRule

The rules for an availability schedule. When creating or updating a schedule, you must include exactly one wday rule for each day of the week (sunday through saturday). date rules are optional overrides on top of the weekly rules. - When type is "wday", the wday field is required and date must be omitted. - When type is "date", the date field is required and wday must be omitted.

- `type` (enum, required) — The type of this Availability Rule; can be "wday" or a specific "date".
  - Allowed values: `wday`, `date`
- `intervals` (list of AvailabilityRuleIntervalsItems, required) — The intervals to be applied to this Rule. Each interval represents when booking a meeting is allowed. If the interval array is empty, then there is no booking availability for that day. Time is in 24h format (i.e. "17:30") and local to the timezone in the Availability Schedule.
- `wday` (enum, optional) — The day of the week for which this Rule should be applied to. Required when type is "wday".
  - Allowed values: `sunday`, `monday`, `tuesday`, `wednesday`, `thursday`, `friday`, `saturday`
- `date` (string, optional) — A specific date that this should be applied to (i.e. "2030-12-31"). Required when type is "date". Format `YYYY-MM-DD`.

### AvailabilitySchedule

The availability schedule set by the user.

- `uri` (string, required) — A URI reference to this Availability Schedule.
- `default` (boolean, required) — This is the default Availability Schedule in use.
- `name` (string, required) — The name of this Availability Schedule.
- `user` (string, required) — A URI reference to a User.
- `timezone` (string, required) — The timezone for which this Availability Schedule is originated in.
- `rules` (list of AvailabilityRule, required) — The rules of this Availability Schedule.

### ErrorResponseDetailsItem

- `message` (string, required)
- `parameter` (string, optional)
- `code` (string, optional)

### UserNotInOrganizationError

Permission Denied or caller not authorized to perform this action

- `title` (enum, optional)
  - Allowed values: `Permission Denied`
- `message` (enum, optional)
  - Allowed values: `This user is not in your organization`

### InsufficientScopeError

Caller does not have required oauth scopes

- `title` (enum, required)
  - Allowed values: `Insufficient scope`
- `message` (enum, required)
  - Allowed values: `This operation requires the scopes listed in the 'required_scopes' array.`
- `required_scopes` (list of string, required)

### AvailabilityRuleIntervalsItems

- `from` (string, required) — Format: `"hh:mm"`
- `to` (string, required) — Format: `"hh:mm"`

## Examples

**Request**

```json
{
  "name": "Office Hours",
  "timezone": "America/Los_Angeles",
  "rules": [
    {
      "type": "wday",
      "intervals": [],
      "wday": "sunday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "monday"
    },
    {
      "type": "wday",
      "intervals": [
        {
          "from": "14:00",
          "to": "16:00"
        }
      ],
      "wday": "tuesday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "wednesday"
    },
    {
      "type": "wday",
      "intervals": [
        {
          "from": "14:00",
          "to": "16:00"
        }
      ],
      "wday": "thursday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "friday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "saturday"
    },
    {
      "type": "date",
      "intervals": [
        {
          "from": "09:00",
          "to": "12:00"
        }
      ],
      "date": "2026-12-22"
    }
  ]
}
```

**Response**

```json
{
  "resource": {
    "uri": "https://api.calendly.com/user_availability_schedule/BBBBBBBBBBBBBBBB",
    "default": false,
    "name": "Office Hours",
    "user": "https://api.calendly.com/users/AAAAAAAAAAAAAAAA",
    "timezone": "America/Los_Angeles",
    "rules": [
      {
        "type": "wday",
        "intervals": [],
        "wday": "sunday"
      },
      {
        "type": "wday",
        "intervals": [],
        "wday": "monday"
      },
      {
        "type": "wday",
        "intervals": [
          {
            "from": "14:00",
            "to": "16:00"
          }
        ],
        "wday": "tuesday"
      },
      {
        "type": "wday",
        "intervals": [],
        "wday": "wednesday"
      },
      {
        "type": "wday",
        "intervals": [
          {
            "from": "14:00",
            "to": "16:00"
          }
        ],
        "wday": "thursday"
      },
      {
        "type": "wday",
        "intervals": [],
        "wday": "friday"
      },
      {
        "type": "wday",
        "intervals": [],
        "wday": "saturday"
      },
      {
        "type": "date",
        "intervals": [
          {
            "from": "09:00",
            "to": "12:00"
          }
        ],
        "date": "2026-12-22"
      }
    ]
  }
}
```

**SDK Code**

```python Office Hours with Date Override
import requests

url = "https://api.calendly.com/user_availability_schedules"

payload = {
    "name": "Office Hours",
    "timezone": "America/Los_Angeles",
    "rules": [
        {
            "type": "wday",
            "intervals": [],
            "wday": "sunday"
        },
        {
            "type": "wday",
            "intervals": [],
            "wday": "monday"
        },
        {
            "type": "wday",
            "intervals": [
                {
                    "from": "14:00",
                    "to": "16:00"
                }
            ],
            "wday": "tuesday"
        },
        {
            "type": "wday",
            "intervals": [],
            "wday": "wednesday"
        },
        {
            "type": "wday",
            "intervals": [
                {
                    "from": "14:00",
                    "to": "16:00"
                }
            ],
            "wday": "thursday"
        },
        {
            "type": "wday",
            "intervals": [],
            "wday": "friday"
        },
        {
            "type": "wday",
            "intervals": [],
            "wday": "saturday"
        },
        {
            "type": "date",
            "intervals": [
                {
                    "from": "09:00",
                    "to": "12:00"
                }
            ],
            "date": "2026-12-22"
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Office Hours with Date Override
const url = 'https://api.calendly.com/user_availability_schedules';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"Office Hours","timezone":"America/Los_Angeles","rules":[{"type":"wday","intervals":[],"wday":"sunday"},{"type":"wday","intervals":[],"wday":"monday"},{"type":"wday","intervals":[{"from":"14:00","to":"16:00"}],"wday":"tuesday"},{"type":"wday","intervals":[],"wday":"wednesday"},{"type":"wday","intervals":[{"from":"14:00","to":"16:00"}],"wday":"thursday"},{"type":"wday","intervals":[],"wday":"friday"},{"type":"wday","intervals":[],"wday":"saturday"},{"type":"date","intervals":[{"from":"09:00","to":"12:00"}],"date":"2026-12-22"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Office Hours with Date Override
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.calendly.com/user_availability_schedules"

	payload := strings.NewReader("{\n  \"name\": \"Office Hours\",\n  \"timezone\": \"America/Los_Angeles\",\n  \"rules\": [\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"sunday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"monday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"tuesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"wednesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"thursday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"friday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"saturday\"\n    },\n    {\n      \"type\": \"date\",\n      \"intervals\": [\n        {\n          \"from\": \"09:00\",\n          \"to\": \"12:00\"\n        }\n      ],\n      \"date\": \"2026-12-22\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Office Hours with Date Override
require 'uri'
require 'net/http'

url = URI("https://api.calendly.com/user_availability_schedules")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Office Hours\",\n  \"timezone\": \"America/Los_Angeles\",\n  \"rules\": [\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"sunday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"monday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"tuesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"wednesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"thursday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"friday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"saturday\"\n    },\n    {\n      \"type\": \"date\",\n      \"intervals\": [\n        {\n          \"from\": \"09:00\",\n          \"to\": \"12:00\"\n        }\n      ],\n      \"date\": \"2026-12-22\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Office Hours with Date Override
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.calendly.com/user_availability_schedules")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Office Hours\",\n  \"timezone\": \"America/Los_Angeles\",\n  \"rules\": [\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"sunday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"monday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"tuesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"wednesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"thursday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"friday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"saturday\"\n    },\n    {\n      \"type\": \"date\",\n      \"intervals\": [\n        {\n          \"from\": \"09:00\",\n          \"to\": \"12:00\"\n        }\n      ],\n      \"date\": \"2026-12-22\"\n    }\n  ]\n}")
  .asString();
```

```php Office Hours with Date Override
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.calendly.com/user_availability_schedules', [
  'body' => '{
  "name": "Office Hours",
  "timezone": "America/Los_Angeles",
  "rules": [
    {
      "type": "wday",
      "intervals": [],
      "wday": "sunday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "monday"
    },
    {
      "type": "wday",
      "intervals": [
        {
          "from": "14:00",
          "to": "16:00"
        }
      ],
      "wday": "tuesday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "wednesday"
    },
    {
      "type": "wday",
      "intervals": [
        {
          "from": "14:00",
          "to": "16:00"
        }
      ],
      "wday": "thursday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "friday"
    },
    {
      "type": "wday",
      "intervals": [],
      "wday": "saturday"
    },
    {
      "type": "date",
      "intervals": [
        {
          "from": "09:00",
          "to": "12:00"
        }
      ],
      "date": "2026-12-22"
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Office Hours with Date Override
using RestSharp;

var client = new RestClient("https://api.calendly.com/user_availability_schedules");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Office Hours\",\n  \"timezone\": \"America/Los_Angeles\",\n  \"rules\": [\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"sunday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"monday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"tuesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"wednesday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [\n        {\n          \"from\": \"14:00\",\n          \"to\": \"16:00\"\n        }\n      ],\n      \"wday\": \"thursday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"friday\"\n    },\n    {\n      \"type\": \"wday\",\n      \"intervals\": [],\n      \"wday\": \"saturday\"\n    },\n    {\n      \"type\": \"date\",\n      \"intervals\": [\n        {\n          \"from\": \"09:00\",\n          \"to\": \"12:00\"\n        }\n      ],\n      \"date\": \"2026-12-22\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Office Hours with Date Override
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Office Hours",
  "timezone": "America/Los_Angeles",
  "rules": [
    [
      "type": "wday",
      "intervals": [],
      "wday": "sunday"
    ],
    [
      "type": "wday",
      "intervals": [],
      "wday": "monday"
    ],
    [
      "type": "wday",
      "intervals": [
        [
          "from": "14:00",
          "to": "16:00"
        ]
      ],
      "wday": "tuesday"
    ],
    [
      "type": "wday",
      "intervals": [],
      "wday": "wednesday"
    ],
    [
      "type": "wday",
      "intervals": [
        [
          "from": "14:00",
          "to": "16:00"
        ]
      ],
      "wday": "thursday"
    ],
    [
      "type": "wday",
      "intervals": [],
      "wday": "friday"
    ],
    [
      "type": "wday",
      "intervals": [],
      "wday": "saturday"
    ],
    [
      "type": "date",
      "intervals": [
        [
          "from": "09:00",
          "to": "12:00"
        ]
      ],
      "date": "2026-12-22"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.calendly.com/user_availability_schedules")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```